/*
 * MosP - Mind Open Source Project         http://www.mosp.jp/
 * Copyright (C) 1987-2008 MIND Co., Ltd.  http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.system.action;

import jp.mosp.common.dao.CmCodeDao;
import jp.mosp.common.dto.CmCodeDto;

import jp.mosp.common.action.MosPAction;
import jp.mosp.common.common.MospConst;
import jp.mosp.common.common.MospException;
import jp.mosp.common.common.MospUtility;
import jp.mosp.system.vo.CmCodeCardVo;

public class CmCodeCardAction extends MosPAction {

	// コマンド
	private static final String CMD_CODE_CARD_SHOW   = "S2005";	// 表示(追加)
	private static final String CMD_CODE_CARD_SELECT = "S2006";	// 表示(選択)
	private static final String CMD_CODE_CARD_INSERT = "S2007";	// 登録
	private static final String CMD_CODE_CARD_UPDATE = "S2008";	// 更新

	/**
	 * コンストラクタ
	 */
	public CmCodeCardAction() {
		super();
	}

	/**
	 * アクション
	 */
	public void action() throws Exception {
		// DBコネクション取得
		getConnection();
		// SYSTEM権限確認
		confirmSystemAuth();
		// VOの取得及び設定
		CmCodeCardVo vo = new CmCodeCardVo();
		vo.initVo(cfg, msg, cmd, aspUser, user);
		vo.setParams(request);
		// VO及びフォワード先URLの設定
		setVo(vo);
		setUrl(vo.getRetUrl());
		// DBコネクション取得
		getConnection();
		// DAOの準備
		CmCodeDao dao;
		dao = new CmCodeDao();
		dao.initDao(cfg, cmd, aspUser, user, conn);
		// コード区分プルダウンリスト作成
		vo.aryPltTId = getCodeArray();
		// DTOの取得
		CmCodeDto dto;
		Object obj = session.getAttribute(MospConst.ATT_DTO);
		dto = obj instanceof CmCodeDto ? (CmCodeDto)obj : null;
		// コマンド毎の処理
		if (cmd.equals(CMD_CODE_CARD_SHOW)) {
			// 表示(新規)
			vo.setPltTId("");
			vo.setTxtTCode("");
			vo.setTxtTName("");
			vo.setTxtIndex("");
			vo.setPltDelete("");
			vo.setMode(CmCodeCardVo.MODE_INSERT);		
		} else if (cmd.equals(CMD_CODE_CARD_SELECT)) {
			// 表示(キーで情報を検索)
			// データの取得
			dto = dao.findForKey(key1, key2);
			chkExist(dto);
			// VOに情報をセット
			vo.setFields(dto);
			vo.setMode(CmCodeCardVo.MODE_UPDATE);
			// セッションにDTOをセット
			session.setAttribute(MospConst.ATT_DTO, dto);
		} else if (cmd.equals(CMD_CODE_CARD_INSERT)) {
			// 新規登録
			dto = insert(vo);
			// セッションにDTOをセット
			session.setAttribute(MospConst.ATT_DTO, dto);
		} else if (cmd.equals(CMD_CODE_CARD_UPDATE)) {	
			// 更新
			dto = update(vo, dto);
			// セッションにDTOをセット
			session.setAttribute(MospConst.ATT_DTO, dto);
		} else {
			throw new MospException(MospConst.EX_CMD_INVALID);
		}
	}

	/**
	 * データ挿入
	 * @param vo 対象VO
	 * @return データ挿入対象DTO
	 * @throws Exception
	 */
	private CmCodeDto insert(CmCodeCardVo vo) throws Exception {
		vo.setPltDelete(String.valueOf(MospConst.DELETE_FLAG_OFF));
		// パラメータの妥当性確認
		vo.validate(true);
		// コネクションの取得及びDAOの準備
		getConnection();
		CmCodeDao dao = new CmCodeDao();
		dao.initDao(cfg, cmd, aspUser, user, conn);
		// 存在チェック
		chkDuplicate(dao.findForKey(vo.getPltTId(), vo.getTxtTCode()), vo);
		// DTOの準備
		CmCodeDto dto = new CmCodeDto();
		vo.setDtoFields(dto);
		// データの挿入
		dao.insert(dto);
		// DTOの再取得
		dto = dao.findForKey(dto.getTId(), dto.getTCode());
		// コミット
		commit();
		// モード設定
		vo.setMode(CmCodeCardVo.MODE_UPDATE);
		// メッセージ設定
		vo.setMessage(MospUtility.getMessage(msg, MospConst.MSG_INSERT, ""));
		return dto;
	}

	/**
	 * データ更新
	 * @param vo 対象VO
	 * @param dto 対象DTO
	 * @return データ挿入対象DTO
	 * @throws Exception
	 */
	private CmCodeDto update(CmCodeCardVo vo, CmCodeDto dto) throws Exception {
		// コード区分取得
		vo.setPltTId(dto.getTId());
		// パラメータの妥当性確認
		vo.validate(false);
		// コネクションの取得及びDAOの準備
		getConnection();
		CmCodeDao dao = new CmCodeDao();
		dao.initDao(cfg, cmd, aspUser, user, conn);
		// 排他確認
		chkExclusive(dto, dao.findForUpdate(vo.getPltTId(), vo.getTxtTCode()), vo);
		// DTOの準備
		vo.setDtoFields(dto);
		// データの更新
		dao.update(dto);
		// DTOの再取得
		CmCodeDto retDto = dao.findForKey(dto.getTId(), dto.getTCode());
		chkUpdate(retDto);
		// コミット
		commit();
		// モード設定
		vo.setMode(CmCodeCardVo.MODE_UPDATE);
		// メッセージ設定
		vo.setMessage(MospUtility.getMessage(msg, MospConst.MSG_UPDATE, ""));
		return retDto;
	}

}
